#! /usr/users/goldnbrg/bin/perl
# NOTE: modify the previous line to point to 
# the appropriate perl for your system

# A little perl script to extract columns from tab-delimited text files
#
#       David P. Goldenberg
#       Department of Biology
#       University of Utah
#       257 South 1400 East
#       Salt Lake City, UT
#
#       goldenberg@biology.utah.edu
#
# Provided at no cost and with absolutely no guarantees!
# But, please report bugs!




# reads files from STDIN and writes to STDOUT

# accepts any number of arguments indicating columns to select. 
# Columns are numbered from 1 and, Columns are output in the order of these arguments

if (@ARGV < 1) {
    die "columns: Extracts columns from tab-delimited text files.
         Reads from STDIN and writes to STDOUT. 
         Usage: >columns colno1 colno2 < infile > outfile \n"
}
          

@OutCol = @ARGV;
# print "@OutCol \n";
while ($line = <STDIN>) {
    chop $line;
    @fields = split ("\t", $line);
    foreach $col (@OutCol) {
#	print "$col \t";
	print "$fields[$col-1] \t";
    }
    print "\n";
}
