# some perl subroutines written by David Goldenberg
# The location of this file must be specified with a 
# use declaration, such as:
#   use lib "/usr/people/davidg/bin";
# Then, the library must be called with:
#   require "dpg.pl";


sub fileSort {
  # subroutine to sort filenames in a "sensible" way
  # that is to use numeric values found in
  # in up to 5 segments separated by "."s
  # starting with the left-most segment

  my (@inNames, $sorted, $name, @segs);
  my ($s0, $s1, $s2, $s3, $s4, $s5);
  @inNames = @_;

  foreach $name (@inNames) {
    @segs = ();
    @segs = split(/\./, $name, 5);
    if ($segs[0]) {
      $s1{$name} = &strNos($segs[0]);
    } else { $s1{$name} = 0 }
    if ($segs[1]) {
      $s2{$name} = &strNos($segs[1]);
    } else { $s2{$name} = 0 }
    if ($segs[2]) {
      $s3{$name} = &strNos($segs[2]);
    } else { $s3{$name} = 0 }
    if ($segs[3]) {
      $s4{$name} = &strNos($segs[3]);
    } else { $s4{$name} = 0 }
    if ($segs[4]) {
      $s5{$name} = &strNos($segs[4]);
    } else { $s5{$name} = 0 }

  }
  @sorted = sort sortSegs @inNames;
  return @sorted;

}

sub strNos {
  # subroutine accepts one input variable
  # returns numbers extracted from the string
  # in the order they appear
  # there is no number, returns 0

  my ($inStr, $lngth, $numbs, $i, $next, $outStr);
  $inStr = $_[0];
  $lngth = length($inStr);
  $outStr = '';
  for ($i = 0; $i < $lngth; $i++) {
    $next = substr($inStr, $i, 1);
    if ($next =~ /\d/) {
      $outStr = $outStr.$next;
    }
  }
  if (!$outStr) { $outStr = 0}
  return $outStr;

}

sub sortSegs {
  # subroutine for sort function
  # as used in the fileSort subroutine
  $s1{$a} <=> $s1{$b}
  or
  $s2{$a} <=> $s2{$b}
  or
  $s3{$a} <=> $s3{$b}
  or
  $s4{$a} <=> $s4{$b}
  or
  $s5{$a} <=> $s5{$b}
  or
  $a cmp $b;
}

# Note: the following line with "1" has to be present
1
