#! /usr/users/goldnbrg/bin/perl

# NOTE: modify the previous line to point to 
# the appropriate perl for your system

# A perl script to generate dyana sequence
# files from fasta format protein sequence files
# A perl script to extract distance information from dg format coordinate files
#
#       David P. Goldenberg
#       Department of Biology
#       University of Utah
#       257 South 1400 East
#       Salt Lake City, UT
#
#       goldenberg@biology.utah.edu
#
# Provided at no cost and with absolutely no guarantees!
# But, please report bugs!


# Assumes just a single sequence in the file
# reads from standard input and writes to
# standard output
# Uses special names for N- and C-terminal residues (NALA, NPHE, CGLY, etc)
&dictionary;

$seq ="";

while ($line = <STDIN>) {
    if ($line =~ /^>/) {
	$line = "#" . substr($line,1);
	print $line;
    } else {
	chop $line;
	$seq = $seq . $line;
    }
}



for ($i = 0; $i < length($seq); $i++) {
    $next = substr($seq,$i,1);
    if ($i==0) {
	print ("N".$dyanaAA{$next}, "\t", $i+1, "\n");
    } elsif ($i==(length($seq)-1)) {
	print ("C".$dyanaAA{$next}, "\t", $i+1, "\n");
    } else {
	print ($dyanaAA{$next}, "\t", $i+1, "\n");
    }
}







sub dictionary {
    # hash to convert 1-letter code to 3-letter code
    # used by dyana
    $dyanaAA{G} = "GLY";
    $dyanaAA{A} = "ALA";
    $dyanaAA{V} = "VAL";
    $dyanaAA{L} = "LEU";
    $dyanaAA{I} = "ILE";
    $dyanaAA{S} = "SER";
    $dyanaAA{T} = "THR";
    $dyanaAA{C} = "CYS";
    $dyanaAA{M} = "MET";
    $dyanaAA{P} = "PRO";
    $dyanaAA{D} = "ASP";
    $dyanaAA{N} = "ASN";
    $dyanaAA{E} = "GLU";
    $dyanaAA{Q} = "GLN";
    $dyanaAA{K} = "LYS";
    $dyanaAA{R} = "ARG";
    $dyanaAA{H} = "HIS";
    $dyanaAA{F} = "PHE";
    $dyanaAA{Y} = "TYR";
    $dyanaAA{W} = "TRP";
}
