#!  /usr/users/goldnbrg/bin/perl
# NOTE: modify the previous line to point to 
# the appropriate perl for your system

# perl script to read two files and merge first columns of each into a single file
#
#       David P. Goldenberg
#       Department of Biology
#       University of Utah
#       257 South 1400 East
#       Salt Lake City, UT
#
#       goldenberg@biology.utah.edu
#
# Provided at no cost and with absolutely no guarantees!
# But, please report bugs!

# Merges first columns of each file into a single file with two entries per line
# accepts two arguments: names of two input files
# writes to STDOUT
# lines are split on space character and only first field is written
# reads lines until end of first file

$inFile1 = shift(@ARGV);
$inFile2 = shift(@ARGV);

open (FILEA,$inFile1);
open (FILEB,$inFile2);


while ($line1 = <FILEA>) {
    @fields1 = split(' ',$line1);
    $line2 = <FILEB>;
    @fields2 = split(' ',$line2);
    print "$fields1[0] \t $fields2[0] \n";
}



close(FILEA);
close(FILEB);


