#! /usr/users/goldnbrg/bin/perl
# NOTE: modify the previous line to point to 
# the appropriate perl for your system

# A perl script to extract radius of gyration
# and hydrodynamic radius from output files
# generated by hydropro

#       David P. Goldenberg
#       Department of Biology
#       University of Utah
#       257 South 1400 East
#       Salt Lake City, UT
#
#       goldenberg@biology.utah.edu
#
# Provided at no cost and with absolutely no guarantees!
# But, please report bugs!


# Converts radie from cm, as output by hydropro, to Angstroms

# reads from stdin, writes to output file identified by single argument

$outFile = shift(@ARGV);


while ($dataLine = <STDIN>) {
    @words = split(" ", $dataLine);
#    print "$words[2] \n";
    if ($words[2] eq 'radius:') {
	$hydroRadius = $words[3] * 1e8;
    }elsif ($words[2] eq 'gyration:') {
	$radGyration = $words[3] * 1e8;
    }
}


if (-e $outFile) {
    open(OUTFILE, ">>" . $outFile);
    print OUTFILE "$radGyration \t $hydroRadius \n";
    close(OUTFILE);
} else {
    open(OUTFILE, ">" . $outFile);
    print OUTFILE "Radius of Gyration \t Hydrodynamic Radius \n";
    print OUTFILE "$radGyration \t $hydroRadius \n";
    close(OUTFILE);
}




