#! /usr/users/goldnbrg/bin/perl

# A perl script to select lines in one file
# based on values listed in a second file 

# The script accepts four command line arguments:
#  name of file with lines to be selected, called "selection file"
#  name of file with values , called "value file"
#  lower bound of acceptable values
#  upper bound of acceptable values

# As lines in value file are read, value is taken as 
# the first space-delimited field

# The selected file lines are written to STDOUT


# Check and parse command line arguments
if (@ARGV != 4) {
    die "Incorrect number of input arguments.  Input: 
         file name 1, file name 2, lower bound, upper bound)";
}


$selectFile = shift(@ARGV);
$valFile = shift(@ARGV);
$vMin = shift(@ARGV);
$vMax = shift(@ARGV);


open (SFILE,$selectFile);
open (VFILE,$valFile);

# Read header from selection file and ignore first line of value file
$header = <SFILE>;
print $header;
<VFILE>;

# Read lines from value and selection files

while ($vline = <VFILE>) {
    @values = split(' ', $vline);
    $sline = <SFILE>;
    if (($values[0] >= $vMin) && ($values[0] <= $vMax)) {
	print $sline;
    }
}

    
close (SFILE);
close (VFILE);
